//type signiture
//Z (boolean), B (byte), C (char), S (short), I (int), J (long), F (float), D (double), LFQCN; (FQCN), [type (迭)	
//////////////////////////////////////////////////////////////////////
//
//    return to JAVA 
//
//////////////////////////////////////////////////////////////////////
//1. string return
JNIEXPORT jstring Java_com_stringFromJNI( JNIEnv* env, jobject thiz)
{
	char strBuffer[128];
	sprintf(strBuffer, "Hello from JNI %s %s", __DATE__, __TIME__);
	return env->NewStringUTF(strBuffer);
}



//////////////////////////////////////////////////////////////////////
//
//    REFERENCE from JAVA
//
//////////////////////////////////////////////////////////////////////
//0. JNIEnv Exception Check
void JNIEnv_ExceptionCheck(JNIEnv* env)
{
	if(env->ExceptionOccurred()) 
	{
		MESSAGELOGE("%s() line(%d) : ERROR!!! ", __FUNCTION__, __LINE__); 
		env->ExceptionDescribe();
		env->ExceptionClear();
	}
}


//1. reference string 
JNIEXPORT jboolean Java_com_crestech_eaglejni_EagleJni_Iinitialize(JNIEnv* env, jobject thiz, jstring Addr)
{
	TChar* WstationIPAddr = NULL; 
	
	WstationIPAddr = (TChar*)env->GetStringUTFChars(Addr, 0);
	
	MESSAGELOGI("WstationIPAddr [%s]\n", WstationIPAddr);	
}


//2. object (class)
JNIEXPORT jboolean Java_com_crestech_eaglejni_EagleJni_Iinitialize(JNIEnv* env, jobject thiz, jobject Listener)
{
	jobject RecvListner = NULL;
	jclass RecvMsgClass = NULL;
	jmethodID InitializeID = NULL ;

	RecvListner = env->NewGlobalRef(Listener);//jobject

	RecvMsgClass = env->GetObjectClass(g_RecvListner);//jclass

	InitializeID = env->GetMethodID(RecvMsgClass, "ResFromEagle_Init", "(I)V");

}

//3. byteArray
JNIEXPORT jboolean Java_com_crestech_eaglejni_EagleJni_ISetPrivateData(JNIEnv* env, jobject thiz, jbyteArray list)
{

	int nListSize = (int)env->GetArrayLength(list);
	
	char* pTemp ;
	jbyte buf[nListSize] ;

	pTemp = (char *)malloc(nListSize+1);
	memset(pTemp, 0x00, nListSize+1);

	env->GetByteArrayRegion(list, 0, nListSize, buf);
	MESSAGELOGI("%s() Line(%d) bufSize(%d)", __FUNCTION__, __LINE__, nListSize);

	strncpy(pTemp, (const char*)buf, nListSize);

}


//////////////////////////////////////////////////////////////////////
//
//    Attached another thread
//
// ε Ƽ ̺귯 JNI thread ܿ ٸ thread  
// java class ޼ҵ带 ̿(ȣ) ϴ  
//////////////////////////////////////////////////////////////////////

//1. get JVM
//System.loadLibrary  native library  ε Ǹ JNI_OnLoad ȣ
//Ƽ ̺귯 ʿ ϴ JNI  RETURN   Ѵ.
// ν Ѱ Ƽ̺귯 ε   

JavaVM * g_JAVAvm = NULL;
JNIEnv* g_env = NULL;
JNIEnv* res_env = NULL; //for new thread


JNIEXPORT jint JNICALL JNI_OnLoad(JavaVM *vm, void *reserved)
{
	jint res;
	g_JAVAvm = vm; // save JavaVM

	/* cache JNIEnv2 interface pointer in global variable */
	res = vm->GetEnv((void **)&g_env, JNI_VERSION_1_4);
	if (res < 0) {
		return res;
	}

	return JNI_VERSION_1_4; /* the required JNI version */
}

//2. VM   : AttachCurrentThread
//3. java class ޼ҵ带 ȣ: CallVoidMethod
void ResponseFromEagleToUI(TUint16 cmd, crErrCode nError)
{

	if(g_JAVAvm == NULL || g_env == NULL) {
		return;
	}
	g_JAVAvm->AttachCurrentThread(&res_env, NULL);

	res_env->CallVoidMethod(jobject, methodID,  (jint)error, (jlong)nCount);

}

//////////////////////////////////////////////////////////////////////
//
//    Attached another thread
//
// java class ޼ҵ忡 object(class) Ÿ  Ͽ ϴ°
//  
//////////////////////////////////////////////////////////////////////


//1. add NewGlobalRef
// ٸ thread  java class   ϱ  ش ̸ global reference  Ͻѳ Ѵ. 
jobject gESGDataClass;
JNIEXPORT jboolean Java_com_crestech_eaglejni_EagleJni_IgetESGData(JNIEnv* env, jobject thiz, jbyte CHNumber, jshort serviceid)
{
	const char* ESGDataeClassPath = "com/crestech/eaglejni/ESGData";

	initESGClassHelper(env, ESGDataeClassPath, &gESGDataClass);

}
void initESGClassHelper(JNIEnv *env, const char *path, jobject *objptr) {
	jclass cls = NULL;
	jmethodID constr  = NULL;
	jobject obj = NULL;

	cls = env->FindClass(path);
	if(!cls) {
		MESSAGELOGE("%s() : failed to get [%s] class reference", __FUNCTION__, path);
		return;
	}

	constr = env->GetMethodID(cls, "<init>", "()V");
	if(!constr) {
		MESSAGELOGE("%s() : failed to get %s constructor", __FUNCTION__, path);
		return;
	}

	obj = env->NewObject(cls, constr);
	if(!obj) {
		MESSAGELOGE("%s() : failed to create a %s object", __FUNCTION__, path);
		return;
	}

	(*objptr) = env->NewGlobalRef(obj); //
	if(!(*objptr)) {
		MESSAGELOGE("%s() : failed to get NewGlobalRef", __FUNCTION__);
		return;
	}
}

//2.  ٸ thread  java class  ȣϴ  
void Response_GetESGData(TInt error, TCommPacketESGDataRes* pData)
{
	if(g_JAVAvm == NULL || g_env == NULL) {
		return;
	}

	g_JAVAvm->AttachCurrentThread(&res_env, NULL);


	jmethodID ESGDataID = NULL;
	ESGDataID = env->GetMethodID(jclass, "ResFromEagle_ESGData", "(ILjava/lang/Object;)V");

	jobject esgObj = MakeJavaObjectArray_ESGServiceData(res_env, pData); //make object

	res_env->CallVoidMethod(g_RecvListner, ESGDataID, (jint)error, esgObj);//java class ȣ
}

//3. MAKE OBJECT
jobject MakeJavaObjectArray_ESGServiceData(JNIEnv* env, TCommPacketESGDataRes* pData )
{
	jclass ESGcls;
	jmethodID ESGmid;
	jobject ESGData;
	
	//find ESGDataClass
	ESGcls = env->GetObjectClass(gESGDataClass);// ̸ س globa ref
	ESGmid = env->GetMethodID(ESGcls, "<init>", "(I[Ljava/lang/Object;)V");
	
	//....
	
	// ESG Service List Array
	jobjectArray ESGServiceArrayObj = NULL;
	ESGServiceArrayObj = MakeJavaObjectArray_Service(env, ServiceCount, pData);
	//ش Ŭ methodID  Ͽ object  
	ESGData = env->NewObject(ESGcls, ESGmid, ServiceCount, ESGServiceArrayObj);
	
	return ESGData;
}
//4. MAKE OBJECT ARRAY
jobjectArray MakeJavaObjectArray_Service(JNIEnv *env, int ListSize, TCommPacketESGDataRes* pData)
{
	MESSAGELOGI("%s() line(%d) Content Count (%d)", __FUNCTION__, __LINE__, ListSize);
	jclass SVCcls;
	jmethodID SVCmid;
	jobject ESGServiceObj = NULL;
	jobjectArray ESGServiceList = NULL;
	
	//find ESGServiceClass
	SVCcls = env->GetObjectClass(gESGServiceClass);
	SVCmid = env->GetMethodID(SVCcls, "<init>", "(ILjava/lang/String;IIII[II[Ljava/lang/Object;)V");

	//make empty array
	int Index = 0;
	ESGServiceList = (jobjectArray)env->NewObjectArray(ListSize, SVCcls, NULL);

	if(ESGServiceList != NULL){
		//get one service in the list
		TCommPacketESGService* Service ;
		for(Index = 0 ; Index < ListSize ; Index++) {
			Service = pData->m_ServiceList.getItem(Index);
			ESGServiceObj = MakeJavaObject_Service(env,  SVCcls, SVCmid, Service);
			JNIEnv_ExceptionCheck(env);
			env->SetObjectArrayElement(ESGServiceList , Index, ESGServiceObj);
		}
	}
	return(ESGServiceList);
}

//5.  MAKE INT ARRAY
void MakeJavaIntArray()
{
	SVCgenreCount = pService->m_ServiceGenre.getCount();	
	MESSAGELOGI("%s() line(%d) SVCgenreCount[%d]", __FUNCTION__, __LINE__, SVCgenreCount);
	if(SVCgenreCount > 0 )
	{
		jint SVCgenre[SVCgenreCount]; 
		SVCgenres_list = env->NewIntArray(SVCgenreCount); 
		if (SVCgenres_list == NULL) { 
			MESSAGELOGE("%s() : failed make intArray \n", __FUNCTION__);
			env->ExceptionDescribe();
			env->ExceptionClear();		
			return NULL; 
		} 

		int Index; //temp
		TCommPacketESGGenre* Temp;
		for (Index = 0; Index < SVCgenreCount; Index++) { 
			Temp = pService->m_ServiceGenre.getItem(Index);
			SVCgenre[Index] = Temp->m_genres;  
			//MESSAGELOGI("%s() line(%d) genre[%d] = (%d)", __FUNCTION__, __LINE__, Index, genre[Index]);
		} 
		env->SetIntArrayRegion(SVCgenres_list, 0, SVCgenreCount, (jint *)SVCgenre); 
	}


}

//6. JAVA CLASS TYPE
public class ESGData {
	public int m_ESGServiceCount;
	public ESGService[] m_SereviceList;
	
	public ESGData(){
		//default constructor
		Log.e("ESGData", "ESGData default consturctor");
	}
	public ESGData(int ServiceCount, Object[] Data){
		m_ESGServiceCount = ServiceCount;
		if(Data != null){
			int nIndex = 0;
			int nCount = m_ESGServiceCount; // Data.length;
			Log.d("ESGData", "Service Count : " + nCount);
			m_SereviceList = new ESGService[nCount];
			
			for(nIndex = 0 ; nIndex < nCount ; nIndex++){
				m_SereviceList[nIndex] = (ESGService) Data[nIndex];
				Log.d("ESGData", "ESG SERVICE DATA : ");
				Log.d("ESGData", nIndex + "]  sName : " + m_SereviceList[nIndex].m_sName);
			}
			
		}
	}
}

//7. JAVA LISTENER 
public void ResFromEagle_ESGData(int error, Object Data)
{
	ESGData Temp = (ESGData) Data;
	ESGService[] ESGSereviceList = new ESGService [Temp.nServiceCount];
	ESGSereviceList[nIndex] = (ESGService)Temp.m_SereviceList[nIndex];
}